/*------------------------------------------------------------------------------
 bin/djv_view/base.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_VIEW_BASE_H
#define DJV_VIEW_BASE_H

#include <djv_image/color.h>
#include <djv_image/io.h>
#include <djv_ui/image.h>

using namespace djv;

// Image display.

class Color : public ui::image::Display {
public:

  Str name;
  
  File lut_file;
  void lut_load();
};

// Image information.

class Info : public image::io::Info {
public:

  File file;
};

// Conversion.

bool serialize(List<Str> *, Color *);
List<Str> serialize(const Color &);

// Labels.

const List<Str> & proxy_label();

#endif

