/*------------------------------------------------------------------------------
 lib/djv_base/user.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "user.h"
#if defined(WIN32)
#include <windows.h>
#else
#include <pwd.h>
#include <unistd.h>
#endif

namespace djv {
namespace user {

Str current()
{
  Str r;

#if defined(WIN32)

  // XXX TCHAR conversion?
  
  TCHAR tmp [str::cstr_size] = { 0 };
  DWORD size = str::cstr_size;
  ::GetUserName(tmp, &size);
  r = Str(tmp);

#else

  r = uid_to_str(::getuid());

#endif

  return r;
}

Str uid_to_str(uid_t in)
{
  Str r;

#if ! defined(WIN32)

  struct passwd * buf = ::getpwuid(in);
  //struct passwd * buf = 0;
  if (buf) r = buf->pw_name;

#endif

  return r;
}

}
}
