/*------------------------------------------------------------------------------
 lib/djv_image/app.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

//#define DJV_DBG
#define _DBG "lib/djv_image/app.cxx"

#include "app.h"
#include <djv_image/gl_pbuffer.h>
#include <djv_image/io.h>

namespace djv {
namespace image {
namespace app {

App::App(const Str & name, int & argc, char ** argv) throw (Error) :
  djv::app::App(name, argc, argv)
{
  DJV_DBG_OBJ2(_DBG, "App::App");
  
  gl::pbuffer::init();
  io::init();
}

App::~App()
{
  DJV_DBG_OBJ2(_DBG, "App::~App");

  io::del();
  gl::pbuffer::del();
}

Str App::info() const
{
  return str::Format(
"%1\n"
"\n"
"Image Load Plugins:\n%2\n"
"\n"
"Image Save Plugins:\n%3"
  ).
    arg(djv::app::App::info()).
    arg(str::join(io::load()->name_list(), ", ")).
    arg(str::join(io::save()->name_list(), ", "));
}

App * app() { return static_cast<djv::image::app::App *>(djv::app::app()); }

}
}
}
