/*------------------------------------------------------------------------------
 lib/djv_image/gl_pbuffer.h
 
 OpenGL Offscreen Buffer

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_IMAGE_GL_PBUFFER_H
#define DJV_IMAGE_GL_PBUFFER_H

#include <djv_image/gl.h>

namespace djv {
namespace image {
namespace gl {
namespace pbuffer {

namespace { class _Pbuffer; }

class Pbuffer {
public:

  Pbuffer(const Vec2i & size, void * context_share = 0) throw (Error);
  ~Pbuffer();

  const Vec2i & size() const;
  
private:

  Pbuffer(const Pbuffer &);
  Pbuffer & operator = (const Pbuffer &);

  _Pbuffer * _p;

  class Context_Restore;
  std::auto_ptr<Context_Restore> _context_restore;
};

// Global.

void init() throw (Error);
void del();

}
}
}
}

#endif

