/*------------------------------------------------------------------------------
 lib/djv_ui/file_browser_fnc.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "_file_browser.h"
#include <djv_ui/style.h>

namespace djv {
namespace ui {
namespace file_browser {

List<int> columns_default_size_list()
{
  return List<int>() <<
    0 <<
    (str_width("000.0000") + style::style()->margin() * 2) <<
#if ! defined(WIN32)
    (str_width("000000") + style::style()->margin() * 2) <<
#endif
    (str_width("000 000 00 00:00:00 0000") + 16 +
      style::style()->margin() * 2);
}

namespace {
std::auto_ptr<Dialog> _dialog;
}

void set(Callback_Base * in, Signal<const File &>::Callback * callback)
{
  dialog()->sig.del();
  dialog()->sig.set(in, callback);
  dialog()->show();
}

void del(Callback_Base * in)
{
  if (! _dialog.get()) return;
  _dialog->sig.del(in);
}

Dialog * dialog()
{
  if (! _dialog.get()) _dialog = std::auto_ptr<Dialog>(new Dialog);
  return _dialog.get();
}

void del()
{
  if (_dialog.get()) _dialog->widget_del();
  _dialog.release();
}

const List<Str> & sort_label()
{
  static const List<Str> data = List<Str>() <<
    djv::file::sort_label()[djv::file::SORT_NAME] <<
    djv::file::sort_label()[djv::file::SORT_SIZE] <<
#if ! defined(WIN32)
    djv::file::sort_label()[djv::file::SORT_USER] <<
#endif
    djv::file::sort_label()[djv::file::SORT_TIME];
  return data;
}

}
}
}
