/*------------------------------------------------------------------------------
 lib/djv_ui/slider.h
 
 Slider Widgets

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_SLIDER_H
#define DJV_UI_SLIDER_H

#include <djv_ui/group.h>
#include <djv_ui/num.h>

namespace djv {
namespace ui {
namespace slider {

// Slider widget base.

class Base : public group::Frame {
public:

  Base();
  virtual ~Base() {}
  
  // Widget.

  virtual int handle(int);
  
  // Layout.

  virtual void handle_size(int);
  virtual int handle_size() const { return _handle_size; }

  virtual void dirty();
  virtual Vec2i size_hint() const { return _size_hint; }
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::slider::Base"; }
  
protected:

  virtual void handle_draw(double value, const Box2i &);
  
private:
  
  int _handle_size;
  Vec2i _size_hint;
};

// Integer slider widget.

class Int : public Base, public num::Int_Base {
public:

  Int();
  virtual ~Int() {}
  
  // Widget.

  virtual int handle(int);
  virtual void draw();

private:

  void value_update();
};

// Float slider widget.

class Float : public Base, public num::Float_Base {
public:
  
  Float();
  virtual ~Float() {}

  // Widget.
 
  virtual int handle(int);
  virtual void draw();

private:

  void value_update();
};

}
}
}

#endif

