/*------------------------------------------------------------------------------
 lib/djv_ui/tab.h
 
 Tab Widget

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_TAB_WIDGET_H
#define DJV_UI_TAB_WIDGET_H

#include <djv_ui/widget.h>
#include <FL/Fl_Tabs.H>

namespace djv {
namespace ui {
namespace tab {

class Widget : public Fl_Tabs, public widget::Base {
public:

  Widget();
  virtual ~Widget() {}
  
  // Value.

  void set(int);
  int get() const;
  Signal<int> sig;

  // Tabs.
  
  void tab_add(const Str & name, widget::Base *);
  void tab_name(const Str & name, int tab);
  void tab_del(int tab);
  void tab_del();
  int tab_size() const { return _list.size(); }
  
  // Widget.
  
  virtual int handle(int);
  virtual void draw();
  
  // Layout.

  virtual void dirty();
  virtual void resize(int, int, int, int);
  virtual Vec2i size_hint() const { return _size_hint; }
  virtual int visible() const { return Fl_Tabs::visible(); }

  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::tab::Widget"; }

private:

  DJV_FL_WIDGET_CALLBACK(Widget, widget_callback);

  List<widget::Base *> _list;
  Vec2i _size_hint;
  Vec2i _size_tab;
};

}
}
}

#endif

