#define DJV_DBG

#include <djv_base/dbg.h>
#include <djv_base/str.h>

using namespace djv;

const struct Format_Test { Str a, b; } format_test [] = {
  { "%1%2%3", "abc" },
  { "%1%2", "ab" },
  { "%1%2%3%4", "abc%4" },
  { "%3%2%1", "cba" },
  { "%2%1", "ba" },
  { "%4%3%2%1", "%4cba" }
};
const int format_test_size = sizeof(format_test) / sizeof(Format_Test);

const int int_test [] = { -1, 0, 1, 10, 100, 1000 };
const int int_test_size = sizeof(int_test) / sizeof(int);

const double float_test [] = { -1.0, 0.0, 1.0, 10.0, 100.0, 1000.0 };
const double float_test_size = sizeof(float_test) / sizeof(double);

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("str");
  
  for (int i = 0; i < format_test_size; ++i) {
    const Str a = str::Format(format_test[i].a).arg("a").arg("b").arg("c");
    DJV_DBG_PRN("format: " << a << " = " << format_test[i].b);
    if (a != format_test[i].b) return 1;
  }

  for (int i = 0; i < int_test_size; ++i) {
    const int value = str::str_to_int(str::int_to_str(int_test[i]));
    DJV_DBG_PRN("int: " << int_test[i] << " = " << value);
    if (value != int_test[i]) return 1;
  }

  for (int i = 0; i < float_test_size; ++i) {
    const double value = str::str_to_float(str::float_to_str(float_test[i]));
    DJV_DBG_PRN("float: " << float_test[i] << " = " << value);
    if (value != float_test[i]) return 1;
  }
  
  return 0;
}
