#define DJV_DBG

#include <djv_image/time.h>

using namespace djv;
using namespace djv::image;

const struct Str_Test { Str a, b; } str_test [] = {
  { "00:00:00:00", "00:00:00:00" },
  { "12:59:59:119", "12:59:59:119" },
  { "1", "00:00:00:1" },
  { "1:2", "00:00:01:02" },
  { "1:2:3", "00:01:02:03" },
  { "1:2:3:4", "01:02:03:04" }
};
const int str_test_size = sizeof(str_test) / sizeof(Str_Test);

int main(int argc, char ** argv)
{
  DJV_DBG_OBJ("timecode");
  
  for (int i = 0; i < str_test_size; ++i) {
    const uint32_t a(image::time::str_to_timecode(str_test[i].a));
    const uint32_t b(image::time::str_to_timecode(str_test[i].b));
    DJV_DBG_PRN("str: " << a << " = " << b);
    if (a != b) return 1;
  }
  
  return 0;
}
