#!/usr/bin/python

import sys
import os
#import commands

#plugin_list = [ "tga", "sgi", "ppm", "dpx", "cineon" ]
plugin_list = [ "tga", "sgi", "ppm", "dpx", "cineon", "exr", "tiff",
  "jpeg", "png" ]
#plugin_list = [ "dpx" ]

ext_list = {
  "tga" : "tga",
  "sgi" : "sgi",
  "ppm" : "ppm",
  "dpx" : "dpx",
  "cineon" : "cin",
  "exr" : "exr",
  "tiff" : "tiff",
  "jpeg" : "jpeg",
  "png" : "png"
}

image_list = [ "grid.ppm", "grid_grey.ppm", "test01.ppm" ]

option_list = {
  "default" : [
    [ "-pixel", [
      '"l u8"', '"la u8"', '"rgb u8"', '"rgba u8"',
      '"rgb u10"',
      '"l u16"', '"la u16"', '"rgb u16"', '"rgba u16"',
      '"l f16"', '"la f16"', '"rgb f16"', '"rgba f16"',
      '"l f32"', '"la f32"', '"rgb f32"', '"rgba f32"'
    ] ],
    #[ "-pixel", [ '"rgb u8"' ] ]
  ],
  "tga" : [
    [ "-save tga compress", [ "none", "rle" ] ]
  ],
  "sgi" : [
    [ "-save sgi compress", [ "none", "rle" ] ]
  ],
  "ppm" : [
    [ "-save ppm type", [ "auto", "u1" ] ],
    [ "-save ppm mode", [ "ascii", "binary" ] ]
  ],
  "dpx" : [
    [ "-save dpx color", [ "raw", "print" ] ],
    [ "-save dpx endian", [ "msb", "lsb", "auto" ] ]
  ],
  "cineon" : [
    [ "-save cineon color", [ "raw", "print" ] ]
  ],
  "exr" : [
    [ "-save exr compress", [ "none", "piz", "zip", "rle" ] ]
  ],
  "tiff" : [
    [ "-save tiff compress", [ "none", "rle", "lzw" ] ]
  ],
  "jpeg" : [
    [ "-save jpeg quality", [ "100", "25" ] ]
  ],
  "png" : []
}

def cmdln_option_build(data, out, i, tmp):

  if len(data[i]) == 0:
    out.append(tmp)
    return

  for j in data[i][1]:
    cmdln_option_build(data, out, i + 1, tmp + " " + data[i][0] + " " + j)

for plugin in plugin_list:

  i = 1
  
  for image in image_list:
    
    tmp_option_list = []
    tmp_option_list.extend(option_list["default"])
    tmp_option_list.extend(option_list[plugin])
    tmp_option_list.append([])

    cmdln_option_list = []
    cmdln_option_build(tmp_option_list, cmdln_option_list, 0, "")
    
    for j in cmdln_option_list:
      
      cmdln = "../../../djv/djv_convert" + " " + image + \
        " out." + str(i) + "." + ext_list[plugin]
      print cmdln + j
      
      #result = commands.getstatusoutput(cmdln + j)
      #print result[1]
      #if result[0] != 0:
      #  sys.exit(1)
      
      result = os.system(cmdln + j)
      if result != 0:
        sys.exit(1);

      i = i + 1
