//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/num_int.h>
#include <djv_ui/num_float.h>
#include <djv_ui/app.h>

using namespace djv;

class App : public ui::app::App {
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, int_callback, int)
    { print(str::Format("value = %1").arg(in)); }
  DJV_CALLBACK(App, float_callback, double)
    { print(str::Format("value = %1").arg(in)); }
  
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  ui::app::App("sliders", argc, argv),
  _window(0)
{
  // Widgets.
  
  ui::num::Int_Slider * int_widget = new ui::num::Int_Slider;
  int_widget->range(0, 1000);
  int_widget->inc(10, 100);
  //int_widget->range(0, 10);
  
  ui::num::Float_Slider * float_widget = new ui::num::Float_Slider;
  float_widget->range(0.0, 100.0);
  float_widget->inc(1.0, 10.0);
  //float_widget->range(0.0, 3.0);
  
  _window = new ui::window::Widget(name());
  
  // Layout.
  
  ui::layout::Vertical * layout = new ui::layout::Vertical(_window);
  layout->add(int_widget);
  layout->add(float_widget);
  
  // Initialize.
  
  _window->size(_window->size_hint());
  _window->show();

  // Callbacks.
  
  int_widget->sig.set(this, int_callback);
  float_widget->sig.set(this, float_callback);
  _window->close_sig.set(this, exit_callback);

  valid(true);
}

App::~App()
{
  if (_window) _window->widget_del();
}

int main(int argc, char ** argv)
{
  return App(argc, argv).exec();
}
